/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __network_ChunkSpool_h__
#define __network_ChunkSpool_h__

namespace fe
{

/**
*/
class FE_DL_EXPORT Chunk : public Counted
{
	public:
		Chunk(const std::string &s);
		Chunk(FE_UWORD size);
virtual	~Chunk(void);

		const void			*buffer(void);
		FE_UWORD				size(void);
		std::string			string(void);

	private:
		std::string			m_string;
};

typedef Spool<Chunk> ChunkSpool;

} /* namespace */

#endif /* __network_ChunkSpool_h__ */

